/******************
blinkhash.js ver. 2012-0503_1.2.1
(C) 2005-2012 Wataru Kanzaki, http://wi-wi.jp/
******************/
var BLINK={
	BlinkSpeed     : 200,
	BlinkTimes     : 3,
	Bar            : ['h1','h2','h3','h4','h5','h6','h7','caption'],
	HighlightStyle : {'background-color':'#ff0000',color:'#009900'},
	ScrollPixels   : 100,
	ScrollSpeed    : 100,
	ConstLeft      : 0,
	ConstTop       : false,
	UseParent      : true,

//do not change;
DefaultStyle:{}
};

function _Blink(){
var wlo=window.location || document.location;
this.host=wlo.host;
this.protocol=wlo.protocol;
this.agt=navigator.userAgent.toLowerCase();
this.platform=navigator.platform.toLowerCase();
this.path=GetPath(wlo.pathname);
this.filename=GetFilename(wlo.pathname);
this.location=this.protocol+"//"+this.host+this.path+this.filename;
this.tim=null;
this.toX=0;
this.toY=0;
this.scrollx=0;
this.scrolly=0;
this.lights=0;
this.hash=null;
this.target=window;
this.bar=null;

this.doClick=function(e){
e=e||window.event;
this._Do(e);
return false;
};
this.doKeydown=function(e){
e=e||window.event;
if(e.keyCode!=13){return true;}
this._Do(e);
return false;
};
this.setBlinkHash=function(hash){
this.hash=hash;
};
this.HashChange=function(e){
var hash=location.hash.substring(1);
if(this.hash!==hash)
Blink._Do({target:{href:location.hash,nodeName:'A',target:'_self'}});
}
this._Do=function(e){
var tar=e.target||e.srcElement;
while(!!tar && (tar.nodeName!='A')){
tar=tar.parentNode;
}
if(!tar)return;
this.hash=GetHash(tar);
if(!this.hash)
return true;
this.target=GetWindow(tar.target);
if(!Compare(tar, this.location, this.target.location.href)){
StopEvent(e);
this.target.location.href=MakePath(GetHref(tar), this.location)+'#'+this.hash;
return false;
}

var ha=GetElement(this.hash, this.target);
if(!ha)
return;
StopEvent(e);
if(this.tim){this.Reset();this.tm=clearTimeout(this.tim);}
this.scrollx=GetScrollLeft();
this.scrolly=GetScrollTop();
var p;
if(window.opera && ha.nodeName.toUpperCase()=='A' && ha.innerHTML==''){
var ns=ha.nextSibling;
while(!!ns && ns.nodeType!=1){
ns=ns.nextSibling;
}
if(!!ns){
p=Pos(ns);
}else{
return;
}
}else{
p=Pos(ha);
}
this.toX=GetScrollToX(p);
this.toY=GetScrollToY(p);
SEARCHBAR:do{
if(BLINK.UseParent && ha.nodeName && ha.nodeName.toUpperCase()=='A'){
var b=ha.parentNode;
var nodeName=b.nodeName.toUpperCase();
for(i=0;i<BLINK.Bar.length;i++){
if(nodeName==BLINK.Bar[i]){
o=b;
break SEARCHBAR;
}
}
b=ha.nextSibling;
while(b && b.nodeType!=1){
b=b.nextSibling;
}
if(!!b){
var nodeName=b.nodeName.toUpperCase();
for(i=0;i<BLINK.Bar.length;i++){
if(nodeName==BLINK.Bar[i]){
o=b;
break SEARCHBAR;
}
}
}
}
for(i=0;i<BLINK.Bar.length;i++){
if(!ha.getElementsByTagName)break SEARCHBAR;
var b=ha.getElementsByTagName(BLINK.Bar[i]);
if(!b){continue;}
o=b[0];
if(!!o)break SEARCHBAR;
}
}while(false);
if(!o){o=ha;}
this.bar=o;
for(var i in BLINK.HighlightStyle){
BLINK.DefaultStyle[i]=GetStyle(o, i);
}
this._Scroll();
};
this.Scroll=function(arg){
if(!arg)
arg={};
if(arg.hash){
this._Do({target:{href:arg.hash,nodeName:'A',target:arg.target||'_self'}});
}else{
if(this.tim){this.Reset();clearTimeout(this.tim);}
this.hash='';
this.target=GetWindow(arg.target||'_self');
this.scrollx=GetScrollLeft();
this.scrolly=GetScrollTop();
var p={y:arg.y||this.scrolly,x:arg.x||this.scrollx};
this.toX=GetScrollToX(p);
this.toY=GetScrollToY(p);
this.bar=null;
this._Scroll();
}
};
this._Scroll=function(){
clearTimeout(Blink.tim);
if(Blink.scrolly==Blink.toY && Blink.scrollx==Blink.toX){
Blink.lights=0;
if(!Blink.usrscroll){
Blink._Blink();
}
return;
}
if(Blink.scrolly<Blink.toY){
Blink.scrolly+=Math.min(Math.ceil((Blink.toY-Blink.scrolly)/2),BLINK.ScrollPixels);
}else{
Blink.scrolly-=Math.min(Math.ceil((Blink.scrolly-Blink.toY)/2),BLINK.ScrollPixels);
}
if(Blink.scrollx<Blink.toX){
Blink.scrollx+=Math.min(Math.ceil((Blink.toX-Blink.scrollx)/2),BLINK.ScrollPixels);
}else{
Blink.scrollx-=Math.min(Math.ceil((Blink.scrollx-Blink.toX)/2),BLINK.ScrollPixels);
}
Blink.target.scrollTo(Blink.scrollx, Blink.scrolly);
Blink.tim=setTimeout("Blink._Scroll()",BLINK.ScrollSpeed);
};
this._Blink=function(){
clearTimeout(this.tim);
if(this.lights>=BLINK.BlinkTimes){
this.Reset();
if(this.target!==window && this.target.Blink){
this.target.Blink.setBlinkHash(this.hash);
}
this.target.location.hash=this.hash;
return;
}
if(++this.lights%2!==0){
this.Highlight();
}else{
this.Reset();
}
this.tim=setTimeout("Blink._Blink()",BLINK.BlinkSpeed);
};
this.Reset=function(){
try{
if(!this.bar||!this.bar.style)return false;
var os=this.bar.style;
for(var i in BLINK.DefaultStyle){
os[i]=BLINK.DefaultStyle[i];
}
}catch(e){return false;}
};
this.Highlight=function(){
try{
if(!this.bar||!this.bar.style)return false;
var os=this.bar.style;
for(var i in BLINK.HighlightStyle){
os[i]=BLINK.HighlightStyle[i];
}
}catch(e){return false;}
};
function GetScrollToX(p){
if(BLINK.ConstLeft===true){
return Blink.scrollx;
}else if(BLINK.ConstLeft===false){
var docw=GetDocumentWidth();
var winw=(document.all && !window.opera)?Max(document.documentElement.offsetWidth):Max(Blink.target.innerWidth);
if(doch===winh){
return p.x;
}else{
var n=docw-winw;
return (n<p.x)?n:p.x;
}
}else{
return BLINK.ConstLeft;
}
}
function GetScrollToY(p){
if(BLINK.ConstTop===true){
return Blink.scrolly;
}else if(BLINK.ConstTop===false){
var doch=GetDocumentHeight();
var winh=(document.all && !window.opera)?Max(document.documentElement.offsetHeight):Max(Blink.target.innerHeight);
if(doch===winh){
return p.y;
}else{
var n=doch-winh;
return (n<p.y)?n:p.y;
}
}else{
return BLINK.ConstTop;
}
}
function GetPath(url){
var str=url.toString();
var RE=RegExp("(.*\/)([^\/]+)$", "");
if(RE.exec(str)){
return RegExp.$1;
}
return str;
}
function GetLocation(url){
return url.toString().replace(/#.*/, "").replace(/\?.*/, "");
}
function GetHash(anc){
if(!anc)
return '';
var url=GetHref(anc);
var p=url.indexOf('#');
return (p==-1)?'':url.substring(p+1);
}
function GetFilename(url){
var str=url.toString();
var RE=RegExp("([^/]+)$","");
if(RE.exec(str)){
return RegExp.$1;
}
return "";
}
function Max() {
var mx=0;
for(var i=0;i<arguments.length;i++){
if(isNaN(arguments[i]))continue;
if(mx<arguments[i]){
mx=arguments[i];
}
}
return mx;
}
function GetStyle(el, prop){
if(!!el.style && el.style[prop]){
return el.style[prop];
}else if(document.defaultView && document.defaultView.getComputedStyle){
prop=prop.replace(/([A-Z])/g, "-$1");
prop=prop.toLowerCase();
return document.defaultView.getComputedStyle(el,"").getPropertyValue(prop);
}else if(el.currentStyle){
return el.currentStyle[prop];
}else{
return null;
}
}
function Pos(id){
var el=GetElement(id);
var rect=el.getBoundingClientRect();
var top=GetScrollTop();
var left=GetScrollLeft();
var width=Max(rect.width,el.clientWidth);
var height=Max(rect.height,el.clientHeight);
return {x:parseInt(left+rect.left),y:parseInt(top+rect.top),w:parseInt(width),h:parseInt(height)};
}
function GetWindow(tar, win) {
if(tar==='_self')
return window;
if(tar==='_top')
return window.top;
if(tar==='_parent')
return window.parent;
if(tar==='_blank')
return null;
win=win||window.top;
var base=document.getElementsByTagName('base');
var baseTar='';
for(var i=0,t;i<base.length;i++){
t=base[i].getAttribute('target');
if(!t||!t.length)
continue;
baseTar=t;
break;
}
if(!tar||tar=='')
tar=baseTar;
if(!tar)
return window;
var frms=[];
for(var i=0;i<win.frames.length;i++){
frms.push(win.frames[i]);
}
for(var i=0;win=frms[i];i++){
if(win.name==tar || win.id==tar){
break;
}
for(var k=0;k<win.frames.length;k++)
frms.push(win.frames[k]);
var doc=win.document||win.documentElement;
if(doc.getElementsByTagName)
for(var k=0,fs=doc.getElementsByTagName('iframe');k<fs.length;k++)
frms.push(fs[k]);
}
return win;
}
function GetElement(en, win) {
if(typeof en != 'string') return en;
var doc=(win)?win.documentElement||win.document:document;
if(!doc) return null;
var els=doc.getElementById(en);
if(els) return els;
var els=doc.getElementsByName(en);
if(!els) return null;
return (els.length)?els[0]:(els.item)?els.item(0):null;
}
this.Create=function(){
if(!!window.RemoveEventListener){
window.RemoveEventListener('load', arguments.callee, false);
}else if(!!window.dettachEvent){
window.dettachEvent('onload', arguments.callee);
}

if(document.getElementsByTagName){
var base=document.getElementsByTagName('base');
if(base && base.length){
var href=base[0].getAttribute('href');
if(href){
Blink.location=href;
var p=href.match(/\/\/([^\/]+)\//);
if(p)
Blink.host=p[1];
var p=href.match(/^(.+:)\/\//);
if(p)
Blink.protocol=p[1];
href=href.replace(/^.+:\/\//, '').replace(/^.+?\//, '');
Blink.path=GetPath(href);
Blink.filename=GetFilename(href);
}
}
}
Parse(document);
BLINK.BlinkTimes*=2;
Blink.HashChange();
};
function MakePath(location, base){
var loc='';
location=GetLocation(location);
if(!location.length)
return base; //anchor='#xxx', same as the document
if(location.indexOf('://')>=0){ //absolute url
loc=location;
}else{
var host='',protocol='http:';
var p=base.match(/\/\/([^\/]+)\//);
if(p)
var host=p[1];
var p=base.match(/^(.+:)\/\//);
if(p)
protocol=p[1];

if(location.indexOf('/')==0){ //absolute path
loc=protocol+'//'+host+location;
}else{
if(base.lastIndexOf('/')!=base.length){
base=base.replace(/[^/]+$/,'');
}
base=base.replace(/^(.+:)\/\//,'');
base=base.replace(/^([^\/]+)\//,'');
var dirs=base.split('/');
var udirs=location.split('/');
for(var i=0;i<udirs.length;i++){
if(udirs[i]=='..'){
dirs.length--;
}else if(udirs[i]=='.'){
; // none
}else{
dirs[dirs.length-1]=udirs[i];
}
}
loc=protocol+'//'+host+'/'+dirs.join('/');
}
}
return loc;
};
function GetHref(anchor){
return (anchor.getAttribute)?anchor.getAttribute('href'):(anchor.href)?anchor.href:'';
}
function Compare(anchor, base, location){
location=MakePath(GetLocation(location||Blink.location), '');
var href=MakePath(GetHref(anchor), base||window.location.href);
return (href==location);
}
function Parse(o){
for(var i=0,a;i<o.links.length;i++){
a=o.links[i];
if(GetHash(a)===''){continue;}
if(!!a.addEventListener){
a.addEventListener('click', function(e){Blink.doClick(e);}, false);
a.addEventListener('keydown', function(e){Blink.doKeydown(e);}, false);
}else if(!!a.attachEvent){
a.attachEvent('onclick', function(e){Blink.doClick(e);});
a.attachEvent('onkeydown', function(e){Blink.doKeydown(e);});
}else{
if(a.onclick){
var f=a.onclick;
a.onclick=function(e){f(e);Blink.doClick(e);}
}else{
a.onclick=function(e){Blink.doClick(e);};
}
if(a.onkeydown){
var f=a.onkeydown;
a.onkeydown=function(e){f(e);Blink.doClick(e);}
}else{
a.onkeydown=function(e){Blink.doKeydown(e);};
}
}
}
}
function GetScrollTop(){
var w=Blink.target;
var doc=w.documentElement||w.document;
var db=(doc.body)?doc.body.scrollTop:0;
var de=(doc.documentElement)?doc.documentElement.scrollTop:0;
return Max(db,de,w.scrollY,w.scrollTop,w.pageYOffset);
}
function GetScrollLeft(){
var w=Blink.target;
var doc=w.documentElement||w.document;
var db=(doc.body)?doc.body.scrollLeft:0;
var de=(doc.documentElement)?doc.documentElement.scrollLeft:0;
return Max(db,de,w.scrollX,w.scrollLeft,w.pageXOffset);
}
function GetDocumentWidth(){
var w=Blink.target;
var doc=w.documentElement||w.document;
if (doc.body){
return Max(doc.width,doc.body.offsetWidth,doc.body.clientWidth);
}else{
return Max(doc.width);
}
}
function GetDocumentHeight(){
var w=Blink.target;
var doc=w.documentElement||w.document;
if(doc.body){
return Max(doc.height,doc.body.offsetHeight,doc.body.clientHeight);
}else{
return Max(doc.height);
}
}
function StopEvent(e){
if(e.preventDefault){
e.preventDefault();
e.stopPropagation();
}else{
e.returnValue=false;
e.cancelBubble=true;
}
return false;
}
}
_Blink.prototype.BlinkInit=function(){
var lcc=function(s){s=s.replace(/-(.)/g, function(m,a){return a.toUpperCase()}).replace(/^(.)/, function(m,a){return a.toLowerCase()});return s;};
var ucc=function(s){return ( s.match(/^moz/) )?'M'+s.substring(1):s;};
for(var i in BLINK.HighlightStyle){
var v=lcc(i);
BLINK.HighlightStyle[v]=BLINK.HighlightStyle[i];
BLINK.HighlightStyle[ucc(v)]=BLINK.HighlightStyle[v];
if( i!==v )
delete BLINK.HighlightStyle[i];
}
for(i=0;i<BLINK.Bar.length;i++){
BLINK.Bar[i]=BLINK.Bar[i].toUpperCase();
}
if(!!window.addEventListener){
window.addEventListener('load', function(e){Blink.Create(e);}, false);
window.addEventListener('hashchange', function(e){Blink.HashChange(e);});
}else if(!!window.attachEvent){
window.attachEvent('onload', function(e){Blink.Create(e);});
window.attachEvent('onhashchange', function(e){Blink.HashChange(e);});
}
return true;
};
var Blink=new _Blink();
Blink.BlinkInit();
